#include <stdio.h>
#include <math.h>

#define PI 3.1415

typedef struct
{
  double real;
  double imag;
} complexnumber;

void add(complexnumber* res,complexnumber* a,complexnumber* b);
void mul(complexnumber* res,complexnumber* a,complexnumber* b);
void sub(complexnumber* res,complexnumber* a,complexnumber* b);
void div(complexnumber* res,complexnumber* a,complexnumber* b);
double magnitude(complexnumber* a);
double angle(complexnumber* a);

void displaycomplexnumber(const char* info,complexnumber* a);

int main(void)
{
  complexnumber a = {1.2,1.8};
  complexnumber b = {-1.2,0.8};
  complexnumber res;

  displaycomplexnumber("A",&a);
  displaycomplexnumber("B",&b);
  add(&res,&a,&b);
  displaycomplexnumber("ADD",&res);
  mul(&res,&a,&b);
  displaycomplexnumber("MUL",&res);
  sub(&res,&a,&b);
  displaycomplexnumber("SUB",&res);
  div(&res,&a,&b);
  displaycomplexnumber("DIV",&res);

  return 0;
}

void add(complexnumber* res,complexnumber* a,complexnumber* b)
{
  res->real = a->real + b->real;
  res->imag = a->imag + b->imag;
}
void mul(complexnumber* res,complexnumber* a,complexnumber* b)
{
  res->real = a->real*b->real-a->imag*b->imag;
  res->imag = a->imag*b->real+a->real*b->imag;
}
void sub(complexnumber* res,complexnumber* a,complexnumber* b)
{
  res->real = a->real - b->real;
  res->imag = a->imag - b->imag;
}
void div(complexnumber* res,complexnumber* a,complexnumber* b)
{
  double tmp = pow(b->real,2)+pow(b->imag,2);
  res->real = (a->real*b->real + a->imag*b->imag)/tmp;
  res->imag = (a->imag*b->real - a->real*b->imag)/tmp;
}
double magnitude(complexnumber* a)
{
  return sqrt(pow(a->real,2)+pow(a->imag,2));
}
double angle(complexnumber* a)
{
  return atan2(a->imag,a->real)*180/PI;
}
void displaycomplexnumber(const char* info,complexnumber* a)
{
  if(info == NULL)
    {
      printf("Real:\t\t%f\nImaginary:\t%f\nMagnitude:\t%f\nAngle:\t\t%f\n",a->real,a->imag,magnitude(a),angle(a));
    }
  else
    {
      printf("%s:\nReal:\t\t%f\nImaginary:\t%f\nMagnitude:\t%f\nAngle:\t\t%f\n",info,a->real,a->imag,magnitude(a),angle(a));
    }
}

